import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

public class ShapeDraw03 extends JFrame {
	private Color color = Color.black;

	private class Shape01 {
		private Color color;
		private Rectangle2D rec;

		private Shape01(Color color, Rectangle2D rec){
			this.color = color;
			this.rec = rec;
		}
	}

	private class JPanel01 extends JPanel {
		private int px, py;
		private int dx, dy;
		private LinkedList shapes = new LinkedList();
		Rectangle2D rec; 

		private JPanel01(){
			setPreferredSize(new Dimension(400, 400));
			setBackground(Color.white);
			MouseInputListener mil = new MouseInputAdapter(){
				public void mousePressed(MouseEvent ev){
					px = ev.getX();
					py = ev.getY();
				}
				public void mouseReleased(MouseEvent ev){
					shapes.add(new Shape01(color, rec));
					rec = null;
				}
				public void mouseDragged(MouseEvent ev){
					dx = ev.getX();
					dy = ev.getY();
					int bx = px, by = py;
					int ex = dx, ey = dy;
					if(dx < px){
						bx = dx;
						ex = px;
					}
					if(dy < py){
						by = dy;
						ey = py;
					}
					rec = new Rectangle2D.Double(bx, by, ex - bx, ey - by);
					repaint();
				}
			};
			addMouseListener(mil);
			addMouseMotionListener(mil);
		}
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D)g;
			if(shapes != null){
				for(int i = 0; i < shapes.size(); i++){
					g2.setColor(((Shape01)shapes.get(i)).color);
					g2.fill(((Shape01)shapes.get(i)).rec);
				}
			}
			g2.setColor(color);
			if(rec != null){
				g2.fill(rec);
			}
		}
	}
	public ShapeDraw03(){
		super("ShapeDraw03 Test");
		final Container pane = getContentPane();
		JToolBar jtb = new JToolBar();
		JButton jb = new JButton("色の選択");
		final JColorChooser jcc = new JColorChooser();
		jb.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ev){
				color = jcc.showDialog(pane, "Choose", Color.black);
			}
		});
		jtb.add(jb);
		pane.add(jtb, BorderLayout.NORTH);
		pane.add(new JPanel01(), BorderLayout.CENTER);
		pack();
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
	}
	public static void main(String[] args){
		new ShapeDraw03();
	}
}
