import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

public class ShapeDraw04 extends JFrame {
	private Color color = Color.black;
	private int type = 0;

	private class Shape01 {
		private Color color;
		private Shape shape;

		private Shape01(Color color, Shape shape){
			this.color = color;
			this.shape = shape;
		}
	}

	private class JPanel01 extends JPanel {
		private int px, py;
		private int dx, dy;
		private LinkedList shapes = new LinkedList();
		Shape shape; 

		private JPanel01(){
			setPreferredSize(new Dimension(400, 400));
			setBackground(Color.white);
			MouseInputListener mil = new MouseInputAdapter(){
				public void mousePressed(MouseEvent ev){
					px = ev.getX();
					py = ev.getY();
				}
				public void mouseReleased(MouseEvent ev){
					shapes.add(new Shape01(color, shape));
					shape = null;
				}
				public void mouseDragged(MouseEvent ev){
					dx = ev.getX();
					dy = ev.getY();
					int bx = px, by = py;
					int ex = dx, ey = dy;
					if(dx < px){
						bx = dx;
						ex = px;
					}
					if(dy < py){
						by = dy;
						ey = py;
					}
					switch(type){
					case 0:
						shape = new Line2D.Double(px, py, dx, dy);
						break;
					case 1:
						shape = new Rectangle2D.Double(bx, by, ex - bx, ey - by);
						break;
					case 2:
						shape = new Ellipse2D.Double(bx, by, ex - bx, ey - by);
						break;
					}
					repaint();
				}
			};
			addMouseListener(mil);
			addMouseMotionListener(mil);
		}
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D)g;
			if(shapes != null){
				for(int i = 0; i < shapes.size(); i++){
					g2.setColor(((Shape01)shapes.get(i)).color);
					g2.draw(((Shape01)shapes.get(i)).shape);
				}
			}
			g2.setColor(color);
			if(shape != null){
				g2.draw(shape);
			}
		}
	}
	public ShapeDraw04(){
		super("ShapeDraw04 Test");
		final Container pane = getContentPane();
		JToolBar jtb = new JToolBar();
		jtb.add(new JButton("ダミー"));
		final JComboBox jcb = new JComboBox(new String[]{"直線", "四角", "楕円"});
		jcb.setPreferredSize(new Dimension(30, 20));
		jcb.setSize(30, 20);
		jcb.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ev){
				type = jcb.getSelectedIndex();
			}
		});
		jtb.add(jcb);
		JButton jb = new JButton("色の選択");
		final JColorChooser jcc = new JColorChooser();
		jb.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ev){
				color = jcc.showDialog(pane, "Choose", Color.black);
			}
		});
		jtb.add(jb);
		pane.add(jtb, BorderLayout.NORTH);
		pane.add(new JPanel01(), BorderLayout.CENTER);
		pack();
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
	}
	public static void main(String[] args){
		new ShapeDraw04();
	}
}
